C***********************************************************************
C    Module:  xplots.f
C 
C    Copyright (C) 2000 Mark Drela 
C 
C    This program is free software; you can redistribute it and/or modify
C    it under the terms of the GNU General Public License as published by
C    the Free Software Foundation; either version 2 of the License, or
C    (at your option) any later version.
C
C    This program is distributed in the hope that it will be useful,
C    but WITHOUT ANY WARRANTY; without even the implied warranty of
C    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
C    GNU General Public License for more details.
C
C    You should have received a copy of the GNU General Public License
C    along with this program; if not, write to the Free Software
C    Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
C***********************************************************************

      SUBROUTINE PLTINI
      INCLUDE 'XFOIL.INC'
C
C---- terminate old plot if any
      IF(LPLOT) CALL PLEND
C
C---- initialize new plot
      IF(LLAND) THEN
        SIGNFR =  SCRNFR
      ELSE
        SIGNFR = -SCRNFR
      ENDIF
      CALL PLOPEN(SIGNFR,IPSLU,IDEV)
      LPLOT = .TRUE.
C
C---- set X-window size in inches (might have been resized by user)
      CALL GETWINSIZE(XWIND,YWIND)
C
C---- draw plot page outline offset by margins
      CALL NEWPEN(5)
      IF(XMARG .GT. 0.0) THEN
        CALL PLOTABS(      XMARG,      YMARG,3)
        CALL PLOTABS(      XMARG,YPAGE-YMARG,2)
        CALL PLOTABS(XPAGE-XMARG,      YMARG,3)
        CALL PLOTABS(XPAGE-XMARG,YPAGE-YMARG,2)
      ENDIF
      IF(YMARG .GT. 0.0) THEN
        CALL PLOTABS(      XMARG,      YMARG,3)
        CALL PLOTABS(XPAGE-XMARG,      YMARG,2)
        CALL PLOTABS(      XMARG,YPAGE-YMARG,3)
        CALL PLOTABS(XPAGE-XMARG,YPAGE-YMARG,2)
      ENDIF
      CALL NEWPEN(1)
C
      CALL PLOTABS(XMARG,YMARG,-3)
      CALL NEWCLIPABS( XMARG, XPAGE-XMARG, YMARG, YPAGE-YMARG )
C
      CALL NEWFACTOR(SIZE)
C
      RETURN
      END


      SUBROUTINE BLPLOT
C------------------------------------------------------
C      Plots various BL variables in x from a menu.
C------------------------------------------------------
      INCLUDE 'XFOIL.INC'
      CHARACTER*4 COMAND
ccc   CHARACTER*4 CHDUM
      REAL XXBL(IVX,2), XXTR(2), WS(IVX,2), XS(IVX,2)
      INTEGER NSIDE(2), IBL1(2), IBL2(2)
C
      CHARACTER*128 COMARG
      CHARACTER*80 FILDEF, LINE
      CHARACTER*2 FILSUF(10)
C
      DIMENSION IINPUT(20)
      DIMENSION RINPUT(20)
      LOGICAL ERROR
C
      DIMENSION DYGARR(10)
      INTEGER NUMBL(2)
C
      EXTERNAL PLCHAR, PLSLAN, PLMATH
C
      DATA LMASK1, LMASK2, LMASK3 / -32640, -30584, -21846 /
      DATA FILSUF / 'hk', 'dT', 'dB', 'ue', 'cf',
     &              'cd', 'nc', 'ct', 'rt', 'rl' /
C
C---- number of grid intervals per axis annotation interval
      NGR = 2
C
C---- clear plot-type indicator (no plot yet)
      KPLOT = 0
C
C---- symbol size
      SH = 0.2*CH
C
C---- get current color for restoration
      CALL GETCOLOR(ICOL0)
C
C---- set up Cartesian BL x-arrays for plotting
      DO IS=1, 2
        DO IBL=2, NBL(IS)
          I = IPAN(IBL,IS)
          XXBL(IBL,IS) = X(I)
          XXTR(IS) = XLE + (XTE-XLE)*XOCTR(IS) - (YTE-YLE)*YOCTR(IS)
        ENDDO
      ENDDO
C
      NSIDE(1) = NBL(2) + IBLTE(1) - IBLTE(2)
      NSIDE(2) = NBL(2)
C
      DO IBLW=1, NBL(2)-IBLTE(2)
        XXBL(IBLTE(1)+IBLW,1) = XXBL(IBLTE(2)+IBLW,2)
      ENDDO
C
C
cC---- max BL coordinate plotted
c      XBLMAX = 1.6
cC
c      DO 3 IS=1, 2
c        DO 31 IBL=2, NSIDE(IS)
c          IF(XXBL(IBL,IS) .LT. XBLMAX) NUMBL(IS) = IBL-1
c 31     CONTINUE
c 3    CONTINUE
C
      NUMBL(1) = NSIDE(1) - 1
      NUMBL(2) = NSIDE(2) - 1
C
C---- plot width (standard width = 1)
      XWIDTH = 0.9
C
C============================
C---- set default plot axis limits
 5    CONTINUE
C
      CHX = 0.99*(XTE - XLE)
      XTEW = XTE + 0.4*CHX
      CALL SCALIT(1,CHX,0.0,XFAC)
      XDEL = 1.0/(5.0*XFAC)
      XMAX = AINT(ABS(XTEW)/XDEL + 0.05) * SIGN(XDEL,XTEW)
      XMIN = AINT(ABS(XLE )/XDEL + 0.05) * SIGN(XDEL,XLE )
C
      HKMAX = 6.0
      HKMIN = 0.0
      HKDEL = 1.0
C
      CALL SCALIT(NUMBL(1),DSTR(2,1),0.0,YFAC)
      DSMAX = 1.0/YFAC
      DSMIN = 0.0
      DSDEL = (DSMAX-DSMIN)/5.0
C
      CALL SCALIT(NUMBL(2),DSTR(2,2),0.0,YFAC)
      DPMAX = 1.0/YFAC
      DPMIN = 0.0
      DPDEL = (DPMAX-DPMIN)/5.0
C
      UEMAX = 1.6
      UEMIN = 0.0
      UEDEL = 0.2
C
      TAUMAX = 0.0
      DISMAX = 0.0
      DO IS=1, 2
        DO IBL=2, NSIDE(IS)
          TAUMAX = MAX(TAUMAX,TAU(IBL,IS))
          DISMAX = MAX(DISMAX,DIS(IBL,IS))
        ENDDO
      ENDDO
      QUE = 0.5*QINF**2
      CALL SCALIT(1,TAUMAX/QUE,0.0,YFAC)
      CFMAX = 0.5/YFAC
      CFMIN = 0.0
      CFDEL = (CFMAX-CFMIN)/5.0
C
      QRF = QINF
      CALL SCALIT(1,DISMAX/QRF**3,0.0,YFAC)
      DIMAX = 0.5/YFAC
      DIMIN = 0.0
      DIDEL = (DIMAX-DIMIN)/5.0
C
C
      ACR1 = MAX(1.0,ACRIT)
      CALL SCALIT(1,ACR1,0.0,YFAC)
      ANDEL = 1.0/(5.0*YFAC)
      ANMAX = ANDEL*AINT(ACR1/ANDEL + 0.6)
      ANMIN = 0.
C
      CMAX = 0.0
      DO IS=1, 2
        DO IBL=ITRAN(IS), NSIDE(IS)
          CMAX = MAX( CMAX , ABS(CTAU(IBL,IS)) )
        ENDDO
      ENDDO
      CALL SCALIT(1,CMAX,0.0,YFAC)
      CTMAX = 1.0/YFAC
      CTMIN = 0.0
      CTDEL = (CTMAX-CTMIN)/5.0
C
      RMAX = 0.0
      DO IS=1, 2
        DO IBL=2, NSIDE(IS)
          RTHETA = REINF * UEDG(IBL,IS)*THET(IBL,IS)
          RMAX = MAX(RMAX,RTHETA)
        ENDDO
      ENDDO
      CALL SCALIT(1,RMAX,0.0,YFAC)
      RTMAX = 1.0/YFAC
      RTMIN = 0.0
      RTDEL = (RTMAX-RTMIN)/5.0
C
      RLMAX = 5.0
      RLMIN = 1.0
      RLDEL = 1.0
C
C
  500 CONTINUE
      CALL ASKC('..VPLO^',COMAND,COMARG)
C
      DO I=1, 20
        IINPUT(I) = 0
        RINPUT(I) = 0.0
      ENDDO
      NINPUT = 0
      CALL GETINT(COMARG,IINPUT,NINPUT,ERROR)
      NINPUT = 0
      CALL GETFLT(COMARG,RINPUT,NINPUT,ERROR)
C
      IF(COMAND.EQ.'    ') RETURN
      IF(COMAND.EQ.'?   ') GO TO 9
      IF(COMAND.EQ.'H   '.OR.
     &   COMAND.EQ.'HK  ') GO TO 10
      IF(COMAND.EQ.'DS  '.OR.
     &   COMAND.EQ.'DT  ') GO TO 20
      IF(COMAND.EQ.'DP  '.OR.
     &   COMAND.EQ.'DB  ') GO TO 30
      IF(COMAND.EQ.'UE  ') GO TO 40
      IF(COMAND.EQ.'CF  ') GO TO 50
      IF(COMAND.EQ.'CD  ') GO TO 60
      IF(COMAND.EQ.'N   ') GO TO 70
      IF(COMAND.EQ.'CT  ') GO TO 80
      IF(COMAND.EQ.'RT  ') GO TO 90
      IF(COMAND.EQ.'RTL ') GO TO 100
      IF(COMAND.EQ.'DUMP') GO TO 120
      IF(COMAND.EQ.'OVER') GO TO 120
      IF(COMAND.EQ.'XLIM' .OR. COMAND.EQ.'X   ') GO TO 131
      IF(COMAND.EQ.'YLIM' .OR. COMAND.EQ.'Y   ') GO TO 132
      IF(COMAND.EQ.'BLOW' .OR. COMAND.EQ.'B   ') GO TO 150
      IF(COMAND.EQ.'RESE' .OR. COMAND.EQ.'R   ') GO TO 5
      IF(COMAND.EQ.'GRID') GO TO 152
      IF(COMAND.EQ.'SYMB') GO TO 153
      IF(COMAND.EQ.'LABE') GO TO 154
      IF(COMAND.EQ.'CLIP') GO TO 155
      IF(COMAND.EQ.'HARD') GO TO 160
      IF(COMAND.EQ.'SIZE') GO TO 165
      IF(COMAND.EQ.'ANNO') GO TO 170
      IF(COMAND.EQ.'Z   ') then
        call usetzoom(.true.,.true.)
        call replot(idev)
        go to 500
      endif
      IF(COMAND.EQ.'U   ') then
        call clrzoom
        call replot(idev)
        go to 500
      endif
C
      WRITE(*,1010) COMAND
      GO TO 500
C
 9    WRITE(*,1050)
      GO TO 500
C
C===================================================
C---- plot Hk
C
 10   KPLOT = 1
C
      HSTINV = GAMM1*(MINF/QINF)**2 / (1.0 + 0.5*GAMM1*MINF**2)
C
C---- fill kinematic shape parameter array
      DO IS=1, 2
        DO IBL=2, NSIDE(IS)
          THI = THET(IBL,IS)
          DSI = DSTR(IBL,IS)
          UEI = UEDG(IBL,IS)
          UC = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
          AMSQ = UC*UC*HSTINV / (GAMM1*(1.0 - 0.5*UC*UC*HSTINV))
          CALL HKIN( DSI/THI, AMSQ, WS(IBL,IS), DUMMY, DUMMY)
        ENDDO
      ENDDO
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- set offsets and scalings
      YMIN = HKMIN
      YMAX = HKMAX
      YDEL = HKDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      YL = YSF*(YMAX-YMIN-1.5*YDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X',0.0,1)
      CALL PLCHAR(-4.0*CH,YL-0.5*CH,1.4*CH,'H',0.0,1)
      CALL PLSUBS(-4.0*CH,YL-0.5*CH,1.4*CH,'k',0.0,1,PLCHAR)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,1)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,1)

c      CALL NEWCOLOR(ICOLS(1))
c      CALL XYLINE(NUMBL(1),XXBL(2,1),GUXQ(2,1),XMIN,XSF,YMIN,YSF,4)
c      CALL XYLINE(NUMBL(1),XXBL(2,1),GUXD(2,1),XMIN,XSF,YMIN,YSF,7)
c      CALL NEWCOLOR(ICOLS(2))
c      CALL XYLINE(NUMBL(2),XXBL(2,2),GUXQ(2,2),XMIN,XSF,YMIN,YSF,4)
c      CALL XYLINE(NUMBL(2),XXBL(2,2),GUXD(2,2),XMIN,XSF,YMIN,YSF,7)

      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NUMBL(1),XXBL(2,1),USLP(2,1),XMIN,XSF,YMIN,YSF,4)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NUMBL(2),XXBL(2,2),USLP(2,2),XMIN,XSF,YMIN,YSF,4)
C
      IF(LBLSYM) THEN
        CALL NEWCOLOR(ICOLS(1))
        CALL XYSYMB(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,SH,1)
        CALL NEWCOLOR(ICOLS(2))
        CALL XYSYMB(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C===================================================
C---- plot top delta*, theta
   20 KPLOT = 2
      IS = 1
      YMIN = DSMIN
      YMAX = DSMAX
      YDEL = DSDEL
      GO TO 35
C
C===================================================
C---- plot bottom delta*, theta
   30 KPLOT = 3
      IS = 2
      YMIN = DPMIN
      YMAX = DPMAX
      YDEL = DPDEL
      GO TO 35
C
C
   35 CONTINUE
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X',0.0,1)
C
      CALL NEWPEN(3)
      IF((YMAX-YMIN)/YDEL .GT. 2.99) THEN
       YL1 = YSF*(YMAX-YMIN-0.5*YDEL)
       YL2 = YSF*(YMAX-YMIN-1.5*YDEL)
       YL3 = YSF*(YMAX-YMIN-2.5*YDEL)
      ELSE
       YL1 = YSF*(YMAX-YMIN-0.25*YDEL)
       YL2 = YSF*(YMAX-YMIN-0.50*YDEL)
       YL3 = YSF*(YMAX-YMIN-0.75*YDEL)
      ENDIF
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL NEWCOLOR(ICOLS(IS))
C
      IF(IS.EQ.1)
     & CALL PLCHAR(-4.5*CH,YL1-0.6*CH,1.3*CH,'Top',0.0, 3)
      IF(IS.EQ.2)
     & CALL PLCHAR(-4.5*CH,YL1-0.6*CH,1.3*CH,'Bot',0.0, 3)
      CALL PLMATH(-4.0*CH,YL2-0.6*CH,1.5*CH,'d'  ,0.0,1)
      CALL PLSUPS(-4.0*CH,YL2-0.6*CH,1.5*CH,'*'  ,0.0,1,PLCHAR)
      CALL PLMATH(-3.5*CH,YL3-0.6*CH,1.5*CH,'q'  ,0.0,1)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      CALL XYLINE(NUMBL(IS),XXBL(2,IS),DSTR(2,IS),XMIN,XSF,YMIN,YSF,1)
      CALL XYLINE(NUMBL(IS),XXBL(2,IS),THET(2,IS),XMIN,XSF,YMIN,YSF,1)
      CALL XYLINE(NUMBL(IS),XXBL(2,IS),DELT(2,IS),XMIN,XSF,YMIN,YSF,2)
C
      IF(LBLSYM) THEN
       CALL XYSYMB(NUMBL(IS),XXBL(2,IS),DSTR(2,IS),
     &             XMIN,XSF,YMIN,YSF,SH,1)
       CALL XYSYMB(NUMBL(IS),XXBL(2,IS),THET(2,IS),
     &             XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C
C===================================================
C---- plot Ue
C
   40 KPLOT = 4
C
C---- fill compressible Ue arrays
      DO IS=1, 2
        DO IBL=2, NSIDE(IS)
          UEI = UEDG(IBL,IS)
          WS(IBL,IS) = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
        ENDDO
      ENDDO
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- set offsets and scalings
      YMIN = UEMIN
      YMAX = UEMAX
      YDEL = UEDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      YL = YSF*(YMAX-YMIN-1.5*YDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.0*CH,'X',0.0,1)
      CALL PLSUBS(-5.0*CH,YL-0.5*CH,1.0*CH,'e'   ,0.0,1,PLCHAR)
      CALL PLCHAR(-5.0*CH,YL-0.5*CH,1.0*CH,'U /V',0.0,4)
      CALL PLMATH(999.0  ,999.0    ,1.0*CH,   '&',0.0,1)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,1)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,1)
C
      IF(LBLSYM) THEN
        CALL NEWCOLOR(ICOLS(1))
        CALL XYSYMB(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,SH,1)
        CALL NEWCOLOR(ICOLS(2))
        CALL XYSYMB(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C============================================
C---- plot Cf
C
   50 KPLOT = 5
C
      QUE = 0.5*QINF**2
      DO IS=1, 2
        DO IBL=2, NSIDE(IS)
          WS(IBL,IS) = TAU(IBL,IS) / QUE
        ENDDO
      ENDDO
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- set offsets and scalings
      YMIN = CFMIN
      YMAX = CFMAX
      YDEL = CFDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      YL = YSF*(YMAX-YMIN-1.5*YDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X',0.0,1)
      CALL PLCHAR(-3.5*CH,YL-0.6*CH,1.4*CH,'C',0.0,1)
      CALL PLSUBS(-3.5*CH,YL-0.6*CH,1.4*CH,'f',0.0,1,PLCHAR)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,1)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,1)
C
      IF(LBLSYM) THEN
        CALL NEWCOLOR(ICOLS(1))
        CALL XYSYMB(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,SH,1)
        CALL NEWCOLOR(ICOLS(2))
        CALL XYSYMB(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C============================================
C---- plot CD
C
   60 KPLOT = 6
C
      QRF = QINF
      DO IS=1, 2
        DO IBL=2, NSIDE(IS)
          WS(IBL,IS) = DIS(IBL,IS) / QRF**3
        ENDDO
      ENDDO
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- set offsets and scalings
      YMIN = DIMIN
      YMAX = DIMAX
      YDEL = DIDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      YL = YSF*(YMAX-YMIN-1.5*YDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X' ,0.0,1)
      CALL PLCHAR(-3.5*CH,YL-0.6*CH,1.4*CH,'C' ,0.0,1)
      CALL PLMATH(-3.7*CH,YL-0.6*CH,1.5*CH,' `',0.0,2)
      CALL PLSUBS(-3.5*CH,YL-0.6*CH,1.4*CH,'D' ,0.0,1,PLSLAN)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,1)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,1)
C
      IF(LBLSYM) THEN
        CALL NEWCOLOR(ICOLS(1))
        CALL XYSYMB(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,SH,1)
        CALL NEWCOLOR(ICOLS(2))
        CALL XYSYMB(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C
C===================================================
C---- plot A/Ao
C
   70 KPLOT = 7
C
C---- set offsets and scalings
      YMIN = ANMIN
      YMAX = ANMAX
      YDEL = ANDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X',0.0,1)
C
      IF((YMAX-YMIN)/YDEL .GT. 1.99) THEN
       YL1 = YSF*(YMAX-YMIN-0.5*YDEL)
       YL2 = YSF*(YMAX-YMIN-1.5*YDEL)
      ELSE
       YL1 = YSF*(YMAX-YMIN-0.33*YDEL)
       YL2 = YSF*(YMAX-YMIN-0.67*YDEL)
      ENDIF
      CALL PLCHAR(-4.0*CH,YL1-0.6*CH,1.2*CH,'ln' ,0.0,2)
      CALL PLCHAR(-5.0*CH,YL2-0.6*CH,1.2*CH,'A/A',0.0,3)
      CALL PLSUBS(-2.6*CH,YL2-0.6*CH,1.2*CH,  '0',0.0,1,PLCHAR)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)

      DO IS=1, 2
        CALL NEWCOLOR(ICOLS(IS))
        NBLS = ITRAN(IS) - 2
        CALL XYLINE(NBLS,XXBL(2,IS),CTAU(2,IS),XMIN,XSF,YMIN,YSF,1)
C
        IF(LBLSYM)
     &  CALL XYSYMB(NBLS,XXBL(2,IS),CTAU(2,IS),XMIN,XSF,YMIN,YSF,SH,1)
C
        IF(.NOT.TFORCE(IS)) THEN
         IBL = ITRAN(IS) - 1
         CALL PLOT((XXBL(IBL,IS)-XMIN)*XSF,(CTAU(IBL,IS)-YMIN)*YSF,3)
         CALL PLOT((XXTR(IS)    -XMIN)*XSF,(ACRIT       -YMIN)*YSF,2)
        ENDIF
      ENDDO
C
      CALL DASH(XSF*XMIN,XSF*XMAX,YSF*(ACRIT-YMIN))
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C===================================================
C---- plot Ctau
C
   80 KPLOT = 8
C
C---- set offsets and scalings
      YMIN = CTMIN
      YMAX = CTMAX
      YDEL = CTDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X',0.0,1)
C
      IF((YMAX-YMIN)/YDEL .GT. 1.99) THEN
       YL1 = YSF*(YMAX-YMIN-0.5*YDEL)
       YL2 = YSF*(YMAX-YMIN-1.5*YDEL)
      ELSE
       YL1 = YSF*(YMAX-YMIN-0.33*YDEL)
       YL2 = YSF*(YMAX-YMIN-0.67*YDEL)
      ENDIF
C
      CALL PLMATH(-3.7*CH,YL1-0.6*CH,1.4*CH,' H',0.0,2)
      CALL PLCHAR(-3.7*CH,YL1-0.6*CH,1.4*CH,'C ',0.0,2)
      CALL PLSUBS(-3.7*CH,YL1-0.6*CH,1.4*CH,'t' ,0.0,1,PLMATH)
C
      CALL PLMATH(-3.7*CH,YL2-0.6*CH,1.4*CH,' H',0.0,2)
      CALL PLCHAR(-3.7*CH,YL2-0.6*CH,1.4*CH,'C ',0.0,2)
      CALL PLSUBS(-3.7*CH,YL2-0.6*CH,1.4*CH,'t' ,0.0,1,PLMATH)
      CALL PLCHAR(-1.8*CH,YL2-1.4*CH,0.7*CH,'eq',0.0,2)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      NBLS = NUMBL(1) - ITRAN(1) + 2
      NBLP = NUMBL(2) - ITRAN(2) + 2
      IT1 = ITRAN(1)
      IT2 = ITRAN(2)
      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NBLS,XXBL(IT1,1),CTAU(IT1,1),XMIN,XSF,YMIN,YSF,1)
cc    CALL XYLINE(NBLS,XXBL(IT1,1), CTQ(IT1,1),XMIN,XSF,YMIN,YSF,4)
      CALL XYLINE(NUMBL(1),XXBL(2,1),CTQ(2,1),XMIN,XSF,YMIN,YSF,4)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NBLP,XXBL(IT2,2),CTAU(IT2,2),XMIN,XSF,YMIN,YSF,1)
CCC   CALL XYLINE(NBLP,XXBL(IT2,2), CTQ(IT2,2),XMIN,XSF,YMIN,YSF,4)
cc      CALL XYLINE(IBLTE(2)-IT2+1,
cc     &                 XXBL(IT2,2), CTQ(IT2,2),XMIN,XSF,YMIN,YSF,4)
      CALL XYLINE(NUMBL(2),XXBL(2,2),CTQ(2,2),XMIN,XSF,YMIN,YSF,4)
C
      IF(LBLSYM) THEN
       CALL NEWCOLOR(ICOLS(1))
       CALL XYSYMB(NBLS,XXBL(IT1,1),CTAU(IT1,1),XMIN,XSF,YMIN,YSF,SH,1)
       CALL NEWCOLOR(ICOLS(2))
       CALL XYSYMB(NBLP,XXBL(IT2,2),CTAU(IT2,2),XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C
C===================================================
C---- plot Rtheta
C
 90   KPLOT = 9
C
C---- 1 / (total enthalpy)
      HSTINV = GAMM1*(MINF/QINF)**2 / (1.0 + 0.5*GAMM1*MINF**2)
C
C---- Sutherland's const./To   (assumes stagnation conditions are at STP)
      HVRAT = 0.35
C
C---- fill Rtheta arrays
      DO 801 IS=1, 2
        DO 8012 IBL=2, NSIDE(IS)
          UEI = UEDG(IBL,IS)
          UE  = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
          HERAT = (1.0 - 0.5*HSTINV*UE  **2)
     &          / (1.0 - 0.5*HSTINV*QINF**2)
          RHOE = HERAT ** (1.0/GAMM1)
          AMUE = SQRT(HERAT**3) * (1.0+HVRAT)/(HERAT+HVRAT)
          RTHETA = REINF * RHOE*UE*THET(IBL,IS)/AMUE
          WS(IBL,IS) = RTHETA
 8012   CONTINUE
 801  CONTINUE
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- set offsets and scalings
      YMIN = RTMIN
      YMAX = RTMAX
      YDEL = RTDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-1)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG = NGR * INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL / FLOAT(NGR)
       CALL NEWPEN(1)
       CALL PLGRID(0.0,0.0, NXG,DXG,NYG,DYG, LMASK2)
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X',0.0,1)
C
      YL = YSF*(YMAX-YMIN-1.5*YDEL)
      CALL PLCHAR(-4.4*CH,YL-0.6*CH,1.4*CH,'Re',0.0,2)
      CALL PLSUBS(-3.0*CH,YL-0.8*CH,1.4*CH, 'q',0.0,1,PLMATH)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,1)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,1)
C
      IF(LBLSYM) THEN
        CALL NEWCOLOR(ICOLS(1))
        CALL XYSYMB(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,SH,1)
        CALL NEWCOLOR(ICOLS(2))
        CALL XYSYMB(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C

cC---- fill and plot Rcrit arrays from AGS bypass transition model
c      DO 803 IS=1, 2
c        DO 8032 IBL=2, NSIDE(IS)
c          THI = THET(IBL,IS)
c          DSI = DSTR(IBL,IS)
c          UEI = UEDG(IBL,IS)
c          UC = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
c          AMSQ = UC*UC*HSTINV / (GAMM1*(1.0 - 0.5*UC*UC*HSTINV))
c          CALL HKIN( DSI/THI, AMSQ, HKI, DUMMY, DUMMY)
c          
c          TRB = 100.0 * EXP( -(ACRIT+8.43)/2.4 )
c          HMI = 1.0/(HKI-1.0)
c          GFUN = 3.625*LOG(TANH(10.0*(HMI - 0.55)) + 6.0)
c          RCR  = 163.0 + EXP((1.0-TRB/6.91)*GFUN)
cC
c          THH = TANH(10.0/(HKI-1.0) - 5.5)
c          RCR = 163.0 + 74.3*(0.55*THH + 1.0)*(0.94*ACRIT + 1.0)
cC
c          WS(IBL,IS) = RCR
c 8032   CONTINUE
c 803  CONTINUE
cC
c      CALL NEWPEN(2)
c      NUM1 = ITRAN(1) - 2
c      NUM2 = ITRAN(2) - 2
c      CALL NEWCOLOR(ICOLS(1))
c      CALL XYLINE(NUM1,XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,2)
c      CALL NEWCOLOR(ICOLS(2))
c      CALL XYLINE(NUM2,XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,2)

      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C===================================================
C---- plot log(Rtheta)
C
 100  KPLOT = 10
C
C---- 1 / (total enthalpy)
      HSTINV = GAMM1*(MINF/QINF)**2 / (1.0 + 0.5*GAMM1*MINF**2)
C
C---- Sutherland's const./To   (assumes stagnation conditions are at STP)
      HVRAT = 0.35
C
C---- fill log(Rtheta) arrays
      DO 901 IS=1, 2
        DO 9012 IBL=2, NSIDE(IS)
          UEI = UEDG(IBL,IS)
          UE  = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
          HERAT = (1.0 - 0.5*HSTINV*UE  **2)
     &          / (1.0 - 0.5*HSTINV*QINF**2)
          RHOE = HERAT ** (1.0/GAMM1)
          AMUE = SQRT(HERAT**3) * (1.0+HVRAT)/(HERAT+HVRAT)
          RTHETA = REINF * RHOE*UE*THET(IBL,IS)/AMUE
          WS(IBL,IS) = 0.
          IF(RTHETA.GT.0.0) WS(IBL,IS) = LOG10(RTHETA)
 9012   CONTINUE
 901  CONTINUE
C
      CALL PLTINI
      CALL PLOT(8.0*CH,6.0*CH,-3)
C
C---- set offsets and scalings
      YMIN = RLMIN
      YMAX = RLMAX
      YDEL = RLDEL
C
      XSF = XWIDTH/(XMAX-XMIN)
      YSF = PLOTAR/(YMAX-YMIN)
C
C---- draw and annotate axes
      CALL NEWPEN(2)
      CALL XAXIS(0.0,0.0,XSF*(XMAX-XMIN),XSF*XDEL,XMIN,XDEL,CH,-2)
      CALL YAXIS(0.0,0.0,YSF*(YMAX-YMIN),YSF*YDEL,YMIN,YDEL,CH,-2)
C
      IF(LBLGRD) THEN
       NXG = NGR * INT((XMAX-XMIN)/XDEL + 0.001)
       NYG =       INT((YMAX-YMIN)/YDEL + 0.001)
       DXG = XSF*XDEL / FLOAT(NGR)
       DYG = YSF*YDEL
       CALL NEWPEN(1)
       KK = 10
       DO K=1, KK
         FRAC = FLOAT(K+1)/FLOAT(K)
         DYGARR(K) = DYG * LOG10(FRAC)
       ENDDO
       DO IG=1, NYG
         YG0 = DYG*FLOAT(IG-1)
         CALL PLGRID(0.0,YG0, NXG,DXG, KK-1+1000,DYGARR, LMASK2)
       ENDDO
      ENDIF
C
      CALL NEWPEN(3)
      XL = XSF*(XMAX-XMIN-1.5*XDEL)
      CALL PLCHAR(XL-0.6*CH,-3.5*CH,1.2*CH,'X',0.0,1)
C
      IF((YMAX-YMIN)/YDEL .GT. 1.99) THEN
       YL1 = YSF*(YMAX-YMIN-0.5*YDEL)
       YL2 = YSF*(YMAX-YMIN-1.5*YDEL)
      ELSE
       YL1 = YSF*(YMAX-YMIN-0.33*YDEL)
       YL2 = YSF*(YMAX-YMIN-0.67*YDEL)
      ENDIF
      CALL PLCHAR(-5.5*CH,YL1-0.6*CH,1.1*CH,'log' ,0.0,3)
      CALL PLSUBS(-3.3*CH,YL1-0.8*CH,1.1*CH,  '10',0.0,2,PLCHAR)
      CALL PLCHAR(-4.4*CH,YL2-0.6*CH,1.4*CH,'Re' ,0.0,2)
      CALL PLSUBS(-3.0*CH,YL2-0.8*CH,1.4*CH, 'q' ,0.0,1,PLMATH)
C
      IF(LVLAB) CALL VLABEL(0.0,YSF*(YMAX-YMIN),CH,
     &                      NAME,
     &                      REINF,MINF,ACRIT,ALFA,
     &                      CL,CD,XOCTR(1),XOCTR(2),
     &                      ICOLS(1),ICOLS(2),LVCONV)
C
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
C
C---- plot upper and lower distributions
      CALL NEWPEN(3)
      CALL NEWCOLOR(ICOLS(1))
      CALL XYLINE(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,1)
      CALL NEWCOLOR(ICOLS(2))
      CALL XYLINE(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,1)
C
      IF(LBLSYM) THEN
        CALL NEWCOLOR(ICOLS(1))
        CALL XYSYMB(NUMBL(1),XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,SH,1)
        CALL NEWCOLOR(ICOLS(2))
        CALL XYSYMB(NUMBL(2),XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,SH,1)
      ENDIF
C

cC---- fill and plot Rcrit arrays from AGS bypass transition model
c      DO 903 IS=1, 2
c        DO 9032 IBL=2, NSIDE(IS)
c          THI = THET(IBL,IS)
c          DSI = DSTR(IBL,IS)
c          UEI = UEDG(IBL,IS)
c          UC = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
c          AMSQ = UC*UC*HSTINV / (GAMM1*(1.0 - 0.5*UC*UC*HSTINV))
c          CALL HKIN( DSI/THI, AMSQ, HKI, DUMMY, DUMMY)
cC          
c          TRB = 100.0 * EXP( -(ACRIT+8.43)/2.4 )
c          HMI = 1.0/(HKI-1.0)
c          GFUN = 3.625*LOG(TANH(10.0*(HMI - 0.55)) + 6.0)
c          RCR  = 163.0 + EXP((1.0-TRB/6.91)*GFUN)
cC
c          WS(IBL,IS) = LOG10(RCR)
c 9032   CONTINUE
c 903  CONTINUE
cC
c      CALL NEWPEN(2)
c      NUM1 = ITRAN(1) - 2
c      NUM2 = ITRAN(2) - 2
c      CALL NEWCOLOR(ICOLS(1))
c      CALL XYLINE(NUM1,XXBL(2,1),WS(2,1),XMIN,XSF,YMIN,YSF,2)
c      CALL NEWCOLOR(ICOLS(2))
c      CALL XYLINE(NUM2,XXBL(2,2),WS(2,2),XMIN,XSF,YMIN,YSF,2)

      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
ccc      CALL ASKC('Hit <cr>^',CHDUM,COMARG)
      GO TO 500
C
C===================================================
 131  CONTINUE
      IF(NINPUT.GE.3) THEN
       XMIN = RINPUT(1)
       XMAX = RINPUT(2)
       XDEL = RINPUT(3)
      ELSE
       WRITE(*,9101) XMIN, XMAX, XDEL
 9101  FORMAT(/' Currently, Xmin,Xmax,Xdel =', 3F11.4,
     &        /' Enter new  Xmin,Xmax,Xdel: ', $ )
       READ(*,*,ERR=131) XMIN, XMAX, XDEL
      ENDIF
C
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C
C===================================================
 120  IF(KPLOT.EQ.0) THEN
       WRITE(*,*) 'No current plot'
       GO TO 500
      ENDIF
C
      IF(COMARG(1:1).NE.' ') THEN
       FNAME = COMARG
      ELSE
C----- no argument... get it somehow
       IF(NPREFIX.GT.0) THEN
C------ offer default using existing prefix
        FILDEF = PREFIX(1:NPREFIX) // '.' // FILSUF(KPLOT)
        WRITE(*,1220) FILDEF
 1220   FORMAT(/' Enter filename:  ', A)
        READ(*,1000) FNAME
        CALL STRIP(FNAME,NFN)
        IF(NFN.EQ.0) FNAME = FILDEF
       ELSE
C------ nothing available... just ask for filename
        CALL ASKS('Enter filename^',FNAME)
       ENDIF
      ENDIF
C
      IF(COMAND.EQ.'DUMP') GO TO 122
      IF(COMAND.EQ.'OVER') GO TO 124
C
C--------------------------------------------
 122  CONTINUE
      LU = 19
      OPEN(LU,FILE=FNAME,STATUS='UNKNOWN')
      REWIND(LU)
C
      WRITE(LU,1001) '#  ', NAME
      WRITE(LU,1003) '#  alpha =', ALFA/DTOR
      WRITE(LU,1003) '#  Mach  =', MINF
      WRITE(LU,1002) '#  Reyn  =', INT(REINF+0.5)
      WRITE(LU,1003) '#  Ncrit =', ACRIT
      WRITE(LU,1001) '#'
      WRITE(LU,1001)
     & '#    x           ', FILSUF(KPLOT)
C         0.234510      0.234510
C
      DO IS = 1, 2
        IBL1(IS) = 2
        IBL2(IS) = NSIDE(IS)
        DO IBL = 2, NSIDE(IS)
          IF(KPLOT.EQ.1) THEN
           THI = THET(IBL,IS)
           DSI = DSTR(IBL,IS)
           UEI = UEDG(IBL,IS)
           UC = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
           AMSQ = UC*UC*HSTINV / (GAMM1*(1.0 - 0.5*UC*UC*HSTINV))
           CALL HKIN( DSI/THI, AMSQ, WS(IBL,IS), DUMMY, DUMMY)
           XS(IBL,IS) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.2 .AND. IS.EQ.1) THEN
           IBL1(1) = 2
           IBL1(2) = 2
           IBL2(1) = NSIDE(IS)
           IBL2(2) = NSIDE(IS)
           WS(IBL,1) = DSTR(IBL,IS)
           WS(IBL,2) = THET(IBL,IS)
           XS(IBL,1) = XXBL(IBL,IS)
           XS(IBL,2) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.3 .AND. IS.EQ.2) THEN
           IBL1(1) = 2
           IBL1(2) = 2
           IBL2(1) = NSIDE(IS)
           IBL2(2) = NSIDE(IS)
           WS(IBL,1) = DSTR(IBL,IS)
           WS(IBL,2) = THET(IBL,IS)
           XS(IBL,1) = XXBL(IBL,IS)
           XS(IBL,2) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.4) THEN
           UEI = UEDG(IBL,IS)
           WS(IBL,IS) = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
           XS(IBL,IS) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.5) THEN
           WS(IBL,IS) = TAU(IBL,IS) / QUE
           XS(IBL,IS) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.6) THEN
           QRF = QINF
           WS(IBL,IS) = DIS(IBL,IS) / QRF**3
           XS(IBL,IS) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.7) THEN
           IBL1(IS) = 2
           IBL2(IS) = ITRAN(IS) - 1
           WS(IBL,IS) = CTAU(2,IS)
           XS(IBL,IS) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.8) THEN
           IBL1(IS) = ITRAN(IS)
           IBL2(IS) = NSIDE(IS)
           WS(IBL,IS) = CTAU(2,IS)
           XS(IBL,IS) = XXBL(IBL,IS)
C
          ELSEIF(KPLOT.EQ.9 .OR. KPLOT.EQ.10) THEN
C--------- 1 / (total enthalpy)
           HSTINV = GAMM1*(MINF/QINF)**2 / (1.0 + 0.5*GAMM1*MINF**2)
C
C--------- Sutherland's const./To   (assumes stagnation conditions are at STP)
           HVRAT = 0.35
C
C--------- fill Rtheta arrays
           UEI = UEDG(IBL,IS)
           UE  = UEI * (1.0-TKLAM) / (1.0 - TKLAM*(UEI/QINF)**2)
           HERAT = (1.0 - 0.5*HSTINV*UE  **2)
     &           / (1.0 - 0.5*HSTINV*QINF**2)
           RHOE = HERAT ** (1.0/GAMM1)
           AMUE = SQRT(HERAT**3) * (1.0+HVRAT)/(HERAT+HVRAT)
           RTHETA = REINF * RHOE*UE*THET(IBL,IS)/AMUE
C
           IF(KPLOT.EQ.9) THEN
            WS(IBL,IS) = RTHETA
           ELSE
            WS(IBL,IS) = LOG10( MAX(RTHETA,1.0) )
           ENDIF
           XS(IBL,IS) = XXBL(IBL,IS)
          ENDIF
        ENDDO
      ENDDO
C
      DO IS = 1, 2
        DO IBL = IBL1(IS), IBL2(IS)
          WRITE(LU,8500) XS(IBL,IS), WS(IBL,IS)
 8500     FORMAT(1X,2G13.5)
        ENDDO
        WRITE(LU,1000)
      ENDDO
C
      CLOSE(LU)
      GO TO 500
C
C--------------------------------------------
 124  CONTINUE
      LU = 19
      OPEN(LU,FILE=FNAME,STATUS='OLD',ERR=128)
C
      IS = 1
      IBL = 1
C
      IBL1(IS) = 2
      IBL2(IS) = 2
C
C---- read and echo header lines
 125  READ(LU,1000,END=127) LINE
      IF(LINE(1:1).EQ.'#') THEN
       WRITE(*,*) LINE(2:80)
       GO TO 125
      ENDIF
C....................................
C---- begin data reading loop
 126  CONTINUE
      IF(LINE(1:10).EQ.'          ') THEN
       IF(IS.EQ.2) THEN
C------ empty line... go plot data
        GO TO 127
       ELSE
C------ blank line denotes start of new side
        IS = IS + 1
        IBL = 1
        IBL1(IS) = 2
        IBL2(IS) = 2
        READ(LU,1000,END=127) LINE
        GO TO 126
       ENDIF
      ENDIF
C
      IF(IBL.GE.IVX) GO TO 127
C
C---- read data from line string
      IBL = IBL+1
      READ(LINE,*,ERR=129) XS(IBL,IS), WS(IBL,IS)
      IBL2(IS) = IBL
C
      READ(LU,1000,END=127) LINE
      GO TO 126
C....................................
C
 127  CLOSE(LU)
C
C---- plot data
      CALL GETCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      IF(LCLIP) CALL NEWCLIP(MAX(XCLIP1,0.),MIN(XCLIP2,XSF*(XMAX-XMIN)),
     &                       MAX(YCLIP1,0.),MIN(YCLIP2,YSF*(YMAX-YMIN)))
      DO IS = 1, 2
        IF(KPLOT.EQ.2) THEN
         CALL NEWCOLOR(ICOLS(1))
        ELSEIF(KPLOT.EQ.3) THEN
         CALL NEWCOLOR(ICOLS(2))
        ELSE
         CALL NEWCOLOR(ICOLS(IS))
        ENDIF
C
        IBL = IBL1(IS)
        NNBL = IBL2(IS) - IBL1(IS) + 1
        SSH = 1.3*SH
        CALL XYSYMB(NNBL,XS(IBL,IS),WS(IBL,IS),
     &              XMIN,XSF,YMIN,YSF,SSH,5)
      ENDDO
      CALL NEWCOLOR(ICOL0)
      CALL NEWCLIP(XCLIP1,XCLIP2,YCLIP1,YCLIP2)
      CALL PLFLUSH
C
C---- set new default prefix
      KDOT = INDEX(FNAME,'.')
      IF(KDOT.EQ.0) THEN
       PREFIX = FNAME
      ELSE
       PREFIX = FNAME(1:KDOT-1)
      ENDIF
      CALL STRIP(PREFIX,NPREFIX)
      GO TO 500
C
 128  CONTINUE
      WRITE(*,*) 'File OPEN error'
      GO TO 500
C
 129  CONTINUE
      WRITE(*,*) 'File READ error'
      CLOSE(LU)
      GO TO 500
C
C===================================================
 132  IF(KPLOT.EQ.0) THEN
       WRITE(*,*) 'No current plot'
       GO TO 500
      ENDIF
C
      IF(NINPUT.GE.3) THEN
       YMIN = RINPUT(1)
       YMAX = RINPUT(2)
       YDEL = RINPUT(3)
      ELSE
       WRITE(*,9201) YMIN, YMAX, YDEL
 9201  FORMAT(/' Currently, Ymin,Ymax,Ydel =', 3F11.4,
     &        /' Enter new  Ymin,Ymax,Ydel :    ', $ )
       READ(*,*,ERR=120) YMIN, YMAX, YDEL
      ENDIF
C
      IF     (KPLOT.EQ.1) THEN
       HKMIN = YMIN
       HKMAX = YMAX
       HKDEL = YDEL
      ELSE IF(KPLOT.EQ.2) THEN
       DSMIN = YMIN
       DSMAX = YMAX
       DSDEL = YDEL
      ELSE IF(KPLOT.EQ.3) THEN
       DPMIN = YMIN
       DPMAX = YMAX
       DPDEL = YDEL
      ELSE IF(KPLOT.EQ.4) THEN
       UEMIN = YMIN
       UEMAX = YMAX
       UEDEL = YDEL
      ELSE IF(KPLOT.EQ.5) THEN
       CFMIN = YMIN
       CFMAX = YMAX
       CFDEL = YDEL
      ELSE IF(KPLOT.EQ.6) THEN
       DIMIN = YMIN
       DIMAX = YMAX
       DIDEL = YDEL
      ELSE IF(KPLOT.EQ.7) THEN
       ANMIN = YMIN
       ANMAX = YMAX
       ANDEL = YDEL
      ELSE IF(KPLOT.EQ.8) THEN
       CTMIN = YMIN
       CTMAX = YMAX
       CTDEL = YDEL
      ELSE IF(KPLOT.EQ.9) THEN
       RTMIN = YMIN
       RTMAX = YMAX
       RTDEL = YDEL
      ELSE IF(KPLOT.EQ.10) THEN
       RLMIN = YMIN
       RLMAX = YMAX
CCC    RLDEL = YDEL
      ENDIF
C
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C
C===================================================
 150  IF(KPLOT.EQ.0) THEN
       WRITE(*,*) 'No current plot'
       GO TO 500
      ENDIF
C
      CALL OFFGET(XMIN,YMIN,XSF,YSF,XWIDTH,PLOTAR,.FALSE.,.TRUE.)
      XMAX = XWIDTH/XSF + XMIN
      YMAX = PLOTAR/YSF + YMIN
C
      CALL SCALIT(1,XMAX,XMIN,XFAC)
      XDEL = 1.0 / (5.0*XFAC)
      SGNMIN = SIGN(1.0,XMIN)
      SGNMAX = SIGN(1.0,XMAX)
      XMIN = XDEL * AINT(ABS(XMIN/XDEL) - 0.5)*SGNMIN
      XMAX = XDEL * AINT(ABS(XMAX/XDEL) + 0.5)*SGNMAX
C
      CALL SCALIT(1,YMAX,YMIN,YFAC)
      YDEL = 1.0 / (5.0*YFAC)
      SGNMIN = SIGN(1.0,YMIN)
      SGNMAX = SIGN(1.0,YMAX)
      YMIN = YDEL * AINT(ABS(YMIN/YDEL) - 0.5)*SGNMIN
      YMAX = YDEL * AINT(ABS(YMAX/YDEL) + 0.5)*SGNMAX
C
      IF     (KPLOT.EQ.1) THEN
       HKMIN = YMIN
       HKMAX = YMAX
       HKDEL = YDEL
      ELSE IF(KPLOT.EQ.2) THEN
       DSMIN = YMIN
       DSMAX = YMAX
       DSDEL = YDEL
      ELSE IF(KPLOT.EQ.3) THEN
       DPMIN = YMIN
       DPMAX = YMAX
       DPDEL = YDEL
      ELSE IF(KPLOT.EQ.4) THEN
       UEMIN = YMIN
       UEMAX = YMAX
       UEDEL = YDEL
      ELSE IF(KPLOT.EQ.5) THEN
       CFMIN = YMIN
       CFMAX = YMAX
       CFDEL = YDEL
      ELSE IF(KPLOT.EQ.6) THEN
       DIMIN = YMIN
       DIMAX = YMAX
       DIDEL = YDEL
      ELSE IF(KPLOT.EQ.7) THEN
       ANMIN = YMIN
       ANMAX = YMAX
       ANDEL = YDEL
      ELSE IF(KPLOT.EQ.8) THEN
       CTMIN = YMIN
       CTMAX = YMAX
       CTDEL = YDEL
      ELSE IF(KPLOT.EQ.9) THEN
       RTMIN = YMIN
       RTMAX = YMAX
       RTDEL = YDEL
      ELSE IF(KPLOT.EQ.10) THEN
       RLMIN = YMIN
       RLMAX = YMAX
CCC    RLDEL = YDEL
      ENDIF
C
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C
C===================================================
 152  LBLGRD = .NOT.LBLGRD
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C
C===================================================
 153  LBLSYM = .NOT.LBLSYM
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C
C===================================================
 154  LVLAB = .NOT.LVLAB
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C
C===================================================
 155  LCLIP = .NOT.LCLIP
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C
C===================================================
 160  IF(LPLOT) CALL PLEND
      LPLOT = .FALSE.
      CALL REPLOT(IDEVRP)
      GO TO 500
C
C===================================================
 165  IF(NINPUT.GE.1) THEN
       SIZE = RINPUT(1)
      ELSE
       WRITE(*,*) 'Current plot-object size =', SIZE
       CALL ASKR('Enter new plot-object size^',SIZE)
      ENDIF
C
      GO TO (500,10,20,30,40,50,60,70,80,90) KPLOT+1
      GO TO 500
C===================================================
 170  IF(LPLOT) THEN
       CALL ANNOT(CH)
      ELSE
       WRITE(*,*) 'No active plot to annotate'
      ENDIF
      GO TO 500
C...................................................................
 1000 FORMAT(A)
 1001 FORMAT(A,A,A,A)
 1002 FORMAT(A,I9)
 1003 FORMAT(A,F9.4)
 1010 FORMAT(1X,A4,' command not recognized.  Type a "?" for list')
 1050 FORMAT(/'   <cr>   Return to OPER menu'
     &      //'   H      Plot kinematic shape parameter'
     &       /'   DT     Plot top    side Dstar and Theta'
     &       /'   DB     Plot bottom side Dstar and Theta'
     &       /'   UE     Plot edge velocity'
     &       /'   CF     Plot skin friction coefficient'
     &       /'   CD     Plot dissipation coefficient'
     &       /'   N      Plot amplification ratio'
     &       /'   CT     Plot max shear coefficient'
     &       /'   RT     Plot Re_theta'
     &       /'   RTL    Plot log(Re_theta)'
     &      //'   DUMP f Write current plot variable to file'
     &       /'   OVER f Overlay current plot variable from file'
     &      //'   X  rrr Change x-axis limits'
     &       /'   Y  rrr Change y-axis limits on current plot'
     &      //'   BLOW   Cursor blowup of current plot'
     &       /'   RESE   Reset to default x,y-axis limits'
     &       /'   SIZE r Change absolute plot-object size'
     &       /'  .ANNO   Annotate plot'
     &       /'   HARD   Hardcopy current plot'
     &      //'   GRID   Toggle grid plotting'
     &       /'   SYMB   Toggle node-symbol plotting'
     &       /'   LABE   Toggle label plotting'
     &       /'   CLIP   Toggle line-plot clipping')
      END


      SUBROUTINE VLABEL(X0,Y0,CH,
     &                  NAME,
     &                  REINF,MINF,ACRIT,ALFA,
     &                  CL,CD,XTRT,XTRB,ICOL1,ICOL2,LVCONV)
      CHARACTER*(*) NAME
      REAL MINF
      LOGICAL LVCONV
C
      EXTERNAL PLCHAR
C
      ADEG = ALFA * 45.0/ATAN(1.0)
      CHN = 1.2*CH
C
      CALL GETCOLOR(ICOL0)
C
      X1 = X0
      X2 = X0 + 16.0*CH
      X3 = X0 + 30.0*CH
      X4 = X0 + 45.0*CH
C
      Y1 = Y0 + 1.5*CH
      Y2 = Y0 + 4.0*CH
      Y3 = Y0 + 6.8*CH
C
      CALL NEWPEN(3)
      CALL PLCHAR(X1,Y3,CHN,NAME,0.0,-1)
C
C
      CALL NEWPEN(2)
      CALL PLCHAR(X1       ,Y2,CH,'Ma = ',0.0,5)
      CALL PLNUMB(X1+5.0*CH,Y2,CH, MINF  ,0.0,4)
C
      CALL PLCHAR(X1        ,Y1        ,CH,'Re = '   ,0.0,5)
      NDIG = 3
      IF(REINF .GE. 9.9995E6) NDIG = 2
      IF(REINF .GE. 99.995E6) NDIG = 1
      IF(REINF .GE. 999.95E6) NDIG = 0
      CALL PLNUMB(X1+ 5.0*CH,Y1        ,CH, REINF*1.E-6,0.0,NDIG)
      CALL PLMATH(X1+10.1*CH,Y1+0.10*CH,0.80*CH,'#'  ,0.0,1)
      CALL PLCHAR(X1+10.9*CH,Y1        ,     CH,'10' ,0.0,2)
      CALL PLMATH(X1+12.9*CH,Y1        ,1.10*CH,  '6',0.0,1)
C
C
      CALL PLMATH(X2       ,Y2,1.2*CH,'a',0.0,1)
      CALL PLCHAR(X2       ,Y2,CH,'   = ',0.0,5)
      CALL PLNUMB(X2+5.0*CH,Y2,CH, ADEG  ,0.0,4)
      CALL PLMATH(999.0    ,Y2,CH,'"'    ,0.0,1)
C
      CALL PLCHAR(X2       ,Y1,CH,'N  = ',0.0,5)
      CALL PLSUBS(X2       ,Y1,CH,'cr'   ,0.0,2,PLCHAR)
      CALL PLNUMB(X2+5.0*CH,Y1,CH,ACRIT  ,0.0,2)
C
C
      CALL PLCHAR(X3       ,Y2,CH,'C  = ',0.0,5)
      CALL PLSUBS(X3       ,Y2,CH, 'L'   ,0.0,1,PLCHAR)
      CALL PLNUMB(X3+5.0*CH,Y2,CH, CL    ,0.0,4)
C
      CALL PLCHAR(X3       ,Y1,CH,'C  = ',0.0,5)
      CALL PLSUBS(X3       ,Y1,CH, 'D'   ,0.0,1,PLCHAR)
      CALL PLNUMB(X3+5.0*CH,Y1,CH, CD    ,0.0,5)
C
C
      CALL NEWCOLOR(ICOL1)
      CALL PLCHAR(X4       ,Y2,CH,'T:x /c = ',0.0,9)
      CALL PLSUBS(X4+2.0*CH,Y2,0.85*CH,'tr'   ,0.0,2,PLCHAR)
      CALL PLNUMB(X4+9.0*CH,Y2,CH, XTRT      ,0.0,4)
C
      CALL NEWCOLOR(ICOL2)
      CALL PLCHAR(X4       ,Y1,CH,'B:x /c = ',0.0,9)
      CALL PLSUBS(X4+2.0*CH,Y1,0.85*CH,'tr'   ,0.0,2,PLCHAR)
      CALL PLNUMB(X4+9.0*CH,Y1,CH, XTRB      ,0.0,4)
C
C
      IF(.NOT.LVCONV) THEN
       CALL NEWCOLORNAME('red')
       XL = X1 + CHN*FLOAT(LEN(NAME)+1)
       CALL PLCHAR(XL,Y3,CHN,'* NOT CONVERGED *',0.0,17)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
C
      RETURN
      END


 
      SUBROUTINE PANPLT
C-----------------------------------------------------
C     Shows panel nodes on current airfoil geometry.
C-----------------------------------------------------
      INCLUDE 'XFOIL.INC'
      LOGICAL LREFIN
ccc      CHARACTER*4 CHDUM
C
      XPLT(XX) = (XX - XOFP)*GSF
      YPLT(YY) = (YY - YOFP)*GSF
C
C---- length of normal tick mark showing panel node
      DSN = 0.01*CHORD
C
      XMIN = X(1)
      XMAX = X(1)
      YMIN = Y(1)
      YMAX = Y(1)
      DO 10 I=2, N
        XMIN = MIN(X(I),XMIN)
        XMAX = MAX(X(I),XMAX)
        YMIN = MIN(Y(I),YMIN)
        YMAX = MAX(Y(I),YMAX)
 10   CONTINUE
C
C---- set scale, offsets, to center airfoil in plot area
      XRANGE = MAX(1.0E-9, XMAX-XMIN)
      YRANGE = MAX(1.0E-9, YMAX-YMIN)
      GSF  = MIN( 1.0/XRANGE , PLOTAR/YRANGE )
      XOFP = XMIN - 0.5*(1.0   -GSF*XRANGE)/GSF - 0.05/GSF
      YOFP = YMIN - 0.5*(PLOTAR-GSF*YRANGE)/GSF - 0.05/GSF
C
C
      CALL PLTINI
C
      CALL GETCOLOR(ICOL0)
C
C---- plot axial chord line
      CALL NEWCOLORNAME('green')
      CALL NEWPEN(1)
      CALL PLOT(XPLT(XLE),YPLT(YLE),3)
      CALL PLOT(XPLT(XTE),YPLT(YTE),2)
C
C---- add tick marks
      DO 20 IT=1, 9
        XOC = FLOAT(IT)/10.0
        XT = XLE + XOC*(XTE-XLE)
        YT = YLE + XOC*(YTE-YLE)
C
        DT = 0.003
        IF(IT.EQ.5) DT = 0.005
        DTX = -DT*(YTE-YLE)
        DTY =  DT*(XTE-XLE)
C
        CALL PLOT(XPLT(XT+DTX),YPLT(YT+DTY),3)
        CALL PLOT(XPLT(XT-DTX),YPLT(YT-DTY),2)
   20 CONTINUE
C
      CALL NEWCOLOR(ICOL0)
C
      I = 1
      CALL PLOT(XPLT(X(I)),YPLT(Y(I)),3)
C
      XOCM = (  (X(I)-XLE)*(XTE-XLE)
     &        + (Y(I)-YLE)*(YTE-YLE) ) / CHORD**2
      DO 40 I=1, N
        XOCI = (  (X(I)-XLE)*(XTE-XLE)
     &          + (Y(I)-YLE)*(YTE-YLE) ) / CHORD**2
C
        IF(S(I).GT.SLE .AND. S(I-1).LE.SLE) THEN
         XOCM = 0.0
         CALL NEWCOLOR(ICOL0)
        ENDIF
C
        IF(S(I).LT.SLE) THEN
C-------- upper surface
          IF(XOCI.LT.XSREF2 .AND. XOCM.GT.XSREF2) THEN
            FRAC = (XSREF2-XOCM)/(XOCI-XOCM)
            XF = X(I-1) + FRAC*(X(I)-X(I-1))
            YF = Y(I-1) + FRAC*(Y(I)-Y(I-1))
            CALL PLOT(XPLT(XF),YPLT(YF),2)
            CALL NEWCOLORNAME('magenta')
          ENDIF
          IF(XOCI.LT.XSREF1 .AND. XOCM.GT.XSREF1) THEN
            FRAC = (XSREF1-XOCM)/(XOCI-XOCM)
            XF = X(I-1) + FRAC*(X(I)-X(I-1))
            YF = Y(I-1) + FRAC*(Y(I)-Y(I-1))
            CALL PLOT(XPLT(XF),YPLT(YF),2)
            CALL NEWCOLOR(ICOL0)
          ENDIF
        ELSE
C-------- lower surface
          IF(XOCI.GT.XPREF1 .AND. XOCM.LT.XPREF1) THEN
            FRAC = (XPREF1-XOCM)/(XOCI-XOCM)
            XF = X(I-1) + FRAC*(X(I)-X(I-1))
            YF = Y(I-1) + FRAC*(Y(I)-Y(I-1))
            CALL PLOT(XPLT(XF),YPLT(YF),2)
            CALL NEWCOLORNAME('magenta')
          ENDIF
          IF(XOCI.GT.XPREF2 .AND. XOCM.LT.XPREF2) THEN
            FRAC = (XPREF2-XOCM)/(XOCI-XOCM)
            XF = X(I-1) + FRAC*(X(I)-X(I-1))
            YF = Y(I-1) + FRAC*(Y(I)-Y(I-1))
            CALL PLOT(XPLT(XF),YPLT(YF),2)
            CALL NEWCOLOR(ICOL0)
          ENDIF
        ENDIF
C
        CALL PLOT(XPLT(X(I)),YPLT(Y(I)),2)
        CALL PLOT(XPLT(X(I)+DSN*NX(I)),YPLT(Y(I)+DSN*NY(I)),2)
        CALL PLOT(XPLT(X(I)),YPLT(Y(I)),3)
C
        XOCM = XOCI
   40 CONTINUE
C
      CALL CANG(X,Y,N,0, IMAX,AMAX)
      CH2 = 0.9*CH
C
      CALL PLOTABS(XMARG,YPAGE-YMARG,3)
      CALL GETLASTXY(XPL,YPL)
      XPL = XPL + 2.0*CH
      YPL = YPL - 3.0*CH
C
      CALL PLCHAR(XPL,YPL,CH,'Current airfoil paneling',0.0,-1)
C
      YPL = YPL - 2.4*CH
      CALL PLCHAR(XPL,YPL,CH2,'No. panel nodes: ',0.0,-1)
      RNUM = FLOAT(N) + 0.1
      CALL PLNUMB(999.0,YPL,CH2,RNUM  ,0.0,-1)
C
      YPL = YPL - 2.4*CH
      CALL PLCHAR(XPL,YPL,CH2,'Max panel angle: ',0.0,-1)
      CALL PLNUMB(999.0,YPL,CH2,AMAX,0.0,2)
      CALL PLMATH(999.0,YPL,CH2,'"' ,0.0,1)
C
      CALL PLFLUSH

ccc      CALL ASKC('hit <cr>^',CHDUM,COMARG)
      CALL PLEND
      LPLOT = .FALSE.
C
      RETURN
      END
 

      SUBROUTINE CPX
C-----------------------------------------
C     Plots Cp vs x, integrated forces, 
C     parameters, and reference data.
C-----------------------------------------
      INCLUDE 'XFOIL.INC'
ccc      CHARACTER*4 CHDUM
C
C---- set x location of label
      XPLT = 0.70
      IF(LFOREF) XPLT = 0.52
C
C---- size and type of reference-data symbol
      SH = 0.7*CH
      ISYM = 5
C
C---- Cp scaling factor
      PFAC = PLOTAR/(CPMAX-CPMIN)
C
C---- determine airfoil box size and location
      CALL AIRLIM(N,X,Y,XMIN,XMAX,YMIN,YMAX)
C
C---- y-offset for airfoil in  Cp vs x  plot
      FACA = FACAIR/(XMAX-XMIN)
      XOFA = XOFAIR*(XMAX-XMIN) - XMIN
      YOFA = YOFAIR*(XMAX-XMIN) - YMAX - CPMAX*PFAC/FACA
C
      CALL PLTINI
C
      CALL GETCOLOR(ICOL0)
C
C---- re-origin for  Cp vs x  plot
      CALL PLOT(0.09 , 0.04 + CPMAX*PFAC + (YMAX-YMIN)*FACA, -3)
C
C---- plot Cp(x) axes
      CALL CPAXES(LCPGRD,
     &            N,X,Y,XOFA,YOFA,FACA,
     &            CPMIN,CPMAX,CPDEL,PFAC,CH,
     &            'XFOIL',VERSION)
C
C---- add displacement surface to airfoil if viscous flag is set
      IF(LVISC) CALL CPDISP(N,X,Y,NX,NY,XOFA,YOFA,FACA,
     &                      IVX,IBLTE,NBL,IPAN,DSTR,ANTE,ICOLS)
C
C---- add sonic Cp dashed line if within plot
      IF(CPSTAR.GE.CPMIN) CALL DASH(0.0,1.0,-CPSTAR*PFAC)
C
      CALL NEWPEN(2)
      IF(LVISC) THEN
C----- plot viscous and inviscid Cp
       ILE1 = IPAN(2,1)
       ILE2 = IPAN(2,2)
C
       N1 = ILE1
       CALL NEWCOLOR(ICOLS(1))
       CALL XYLINE(N1,X(1),CPV(1),-XOFA,FACA,0.0,-PFAC,1)
C
       N2 = N - ILE2 + 1
       CALL NEWCOLOR(ICOLS(2))
       CALL XYLINE(N2,X(ILE2),CPV(ILE2),-XOFA,FACA,0.0,-PFAC,1)
C
       CALL NEWCOLOR(ICOL0)
       CALL XYLINE(NW,X(N+1),CPV(N+1),-XOFA,FACA,0.0,-PFAC,1)
C
       CALL NEWPEN(1)
       CALL CPDASH(N+NW,X,CPI, XOFA,FACA,PFAC)
      ELSE
C----- plot inviscid Cp only
       CALL XYLINE(N,X,CPI,-XOFA,FACA,0.0,-PFAC,1)
      ENDIF
C
C
C
      IF(LCPREF) THEN
       CALL GETXYL(IQX,NCPREF,XPREF,CPREF,LABREF,
     &             'Enter Cp vs x data filename^')
C
       CALL NEWCOLORNAME('cyan')
       CALL NEWPEN(2)
       DO K=1, NCPREF
         CALL PLSYMB((XPREF(K)+XOFA)*FACA,-PFAC*CPREF(K),
     &               SH,ISYM,0.0,0)
       ENDDO
       CALL NEWCOLOR(ICOL0)
      ENDIF
C
C---- plot force coefficient
      YPLT = -CPMIN*PFAC
      CALL COEFPL(XPLT,YPLT,CH,LVISC,LFOREF,LVCONV,
     &            NAME,NNAME,
     &            REINF,MINF,ACRIT,ALFA,CL,CM,CD,CDP)
C
      IF(LFOREF) THEN
       CALL NEWCOLORNAME('cyan')
       YPLT = -CPMIN*PFAC
       CALL FOREF(XPLT,YPLT,CH,LVISC, MINF)
       CALL NEWCOLOR(ICOL0)
      ENDIF
C
      IF(LCPREF .AND. NCPREF.GT.0 .AND. LABREF(1:1).NE.' ') THEN
       CALL NEWCOLORNAME('cyan')
       YPLT = YPLT - 3.5*CH
       CALL PLSYMB(XPLT-1.0*CH,YPLT+0.5*CH,SH,ISYM  ,0.0, 0)
       CALL PLCHAR(XPLT+1.0*CH,YPLT       ,CH,LABREF,0.0,-1)
       CALL NEWCOLOR(ICOL0)
      ENDIF
C

      CALL PLFLUSH
C
ccc      CALL ASKC('hit <cr>^',CHDUM,COMARG)
      RETURN
      END
 

      SUBROUTINE GETXYL(NDIM,N,X,Y,LABEL,PROMPT)
C---------------------------------------------
C     Reads reference x,y data, with label
C---------------------------------------------
      DIMENSION X(NDIM), Y(NDIM)
      CHARACTER*(*) LABEL, PROMPT
C
      CHARACTER*128 FNAME
      LU = 2
C
      N = 0
C
      CALL ASKS(PROMPT,FNAME)
      OPEN(LU,FILE=FNAME,STATUS='OLD',ERR=98)
C
C---- read first line for possible label
      READ(LU,1000) LABEL
 1000 FORMAT(A)
C
      K1 = 1
      READ(LABEL,*,ERR=10) X(K1), Y(K1)
      K1 = 2
C
 10   DO K = K1, NDIM
        READ(LU,*,END=15,ERR=99) X(K), Y(K)
      ENDDO
 15   N = K-1
      CLOSE(LU)
C
      KP = INDEX(LABEL,'#')
      IF(KP.EQ.0) THEN
       CALL ASKS('Enter data description label^',LABEL)
      ELSE
       LABEL(KP:KP) = ' '
      ENDIF
C
      CALL STRIP(LABEL,NLABEL)
      RETURN
C
   98 WRITE(*,*) 'GETXYL: File OPEN error.'
      RETURN
C
   99 WRITE(*,*) 'GETXYL: File READ error.'
      CLOSE(LU)
      RETURN
C
      END



      SUBROUTINE AIRLIM(N,X,Y,XMIN,XMAX,YMIN,YMAX)
      DIMENSION X(N),Y(N)
C-----------------------------------------
C     Sets airfoil width and thickness 
C     for airfoil plot space allocation.
C-----------------------------------------
C
      XMIN = X(1)
      XMAX = X(1)
      YMIN = Y(1)
      YMAX = Y(1)
      DO 4 I=1, N
        XMIN = MIN(XMIN,X(I))
        XMAX = MAX(XMAX,X(I))
        YMIN = MIN(YMIN,Y(I))
        YMAX = MAX(YMAX,Y(I))
 4    CONTINUE
      AIRDX = XMAX - XMIN
      AIRDY = YMAX - YMIN
C
C---- round up to nearest 10% of max dimension
      AIRDIM = MAX( AIRDX, AIRDY )
      AIRDX = 0.05*AIRDIM * AINT(AIRDX/(0.05*AIRDIM) + 1.2)
      AIRDY = 0.05*AIRDIM * AINT(AIRDY/(0.05*AIRDIM) + 1.2)
C
      XAVG = 0.5*(XMAX+XMIN)
      YAVG = 0.5*(YMAX+YMIN)
C
      XMIN = XAVG - 0.5*AIRDX
      XMAX = XAVG + 0.5*AIRDX
      YMIN = YAVG - 0.5*AIRDY
      YMAX = YAVG + 0.5*AIRDY
C
C---- fudge y-space again to 25% of plot width
      DDY = MIN( AIRDY , 0.25*AIRDX ) - AIRDY
C
C---- fudge y limits to match fudged y space, keeping average y the same
      YMIN = YMIN - 0.5*DDY
      YMAX = YMAX + 0.5*DDY
C
      RETURN
      END 



      SUBROUTINE CPAXES(LGRID,
     &                  N,X,Y,XOFA,YOFA,FACA,
     &                  CPMIN,CPMAX,CPDEL,PFAC,CH,
     &                  CODE,VERSION)
C----------------------------------------------
C     Plots axes and airfoil for Cp vs x plot
C----------------------------------------------
      LOGICAL LGRID
      DIMENSION X(N),Y(N)
      CHARACTER*(*) CODE
C
      EXTERNAL PLCHAR
C
      DATA LMASK1, LMASK2, LMASK3 / -32640, -30584, -21846 /
C
C---- plot Cp axis from Cpmax to Cpmin
      CALL NEWPEN(2)
      CALL YAXIS(0.0,-CPMAX*PFAC,-(CPMIN-CPMAX)*PFAC,-CPDEL*PFAC,
     &           CPMAX,CPDEL,0.9*CH,1)
      CALL NEWPEN(3)
      YLAB = (FLOAT(INT(CPMIN/CPDEL + 0.01)/2) + 0.5)
     &     * (-CPDEL)*PFAC - 0.6*CH
      CALL PLCHAR(-4.0*CH,YLAB,1.4*CH,'C',0.0,1)
      CALL PLSUBS(-4.0*CH,YLAB,1.4*CH,'p',0.0,1,PLCHAR)
C
C---- plot Cp=0 line
      CALL NEWPEN(1)
      CALL PLOT(0.0,0.0,3)
      CALL PLOT(1.0,0.0,2)
C
C---- add tick marks
      DO 10 IT=0, 2
        XTIK = 0.5*FLOAT(IT)
        CALL PLOT((XTIK+XOFA)*FACA,0.005,3)
        CALL PLOT((XTIK+XOFA)*FACA,-.005,2)
   10 CONTINUE
C
      DO 15 IT=1, 9
        XTIK = 0.1*FLOAT(IT)
        CALL PLOT((XTIK+XOFA)*FACA,0.0025,3)
        CALL PLOT((XTIK+XOFA)*FACA,-.0025,2)
   15 CONTINUE
C
C---- plot airfoil contour
      CALL NEWPEN(2)
      CALL PLOT((X(1)+XOFA)*FACA,(Y(1)+YOFA)*FACA,3)
      DO 20 I=2, N
        CALL PLOT((X(I)+XOFA)*FACA,(Y(I)+YOFA)*FACA,2)
   20 CONTINUE
C
C---- plot code identifier
      CALL NEWPEN(2)
      CHI = 0.60*CH
      CHJ = 0.50*CH
      LENC = LEN(CODE)
      CALL PLCHAR(    CHI,-CPMIN*PFAC-1.0*CHI,CHI,CODE   ,0.0,LENC)
      CALL PLCHAR(    CHI,-CPMIN*PFAC-3.0*CHI,CHJ,'V'    ,0.0,1)
      CALL PLNUMB(3.0*CHJ,-CPMIN*PFAC-3.0*CHI,CHJ,VERSION,0.0,2)
C
      IF(LGRID) THEN
       X0 = XOFA*FACA
       Y0 = -CPMAX*PFAC
       NXG = 10
       NYG = INT((CPMIN-CPMAX)/CPDEL + 0.01) * 5
       DXG = 0.1*FACA 
       DYG = -CPDEL*PFAC / 5.0
       CALL NEWPEN(1)
       CALL PLGRID(X0,Y0, NXG,DXG, NYG,DYG, LMASK2 )
      ENDIF
C
      RETURN
      END



      SUBROUTINE CPDISP(N,X,Y,NX,NY,XOFA,YOFA,FACA,
     &                  IVX,IBLTE,NBL,IPAN,DSTR,ANTE,ICOLS)
C----------------------------------------------
C     Plots displacement surface on airfoil
C----------------------------------------------
      REAL NX,NY
      DIMENSION X(N),Y(N),NX(N),NY(N)
      DIMENSION IBLTE(2),NBL(2),IPAN(IVX,2)
      DIMENSION DSTR(IVX,2)
      DIMENSION ICOLS(2)
C
      CALL GETCOLOR(ICOL0)
      CALL NEWPEN(1)
C
C---- plot displacement surface on both airfoil sides
      DO 40 IS=1, 2
        IPEN = 3
        DO 410 IBL=2, IBLTE(IS)
          I = IPAN(IBL,IS)
          XPLT = X(I) + NX(I)*DSTR(IBL,IS)
          YPLT = Y(I) + NY(I)*DSTR(IBL,IS)
          CALL NEWCOLOR(ICOLS(IS))
          CALL PLOT((XPLT+XOFA)*FACA,(YPLT+YOFA)*FACA,IPEN)
          IPEN = 2
  410   CONTINUE
   40 CONTINUE
C
      IS = 2
C
C---- set upper and lower wake Dstar fractions based on first wake point
      DSTRTE = DSTR(IBLTE(IS)+1,IS)
      IF(DSTRTE.NE.0.0) THEN
       DSF1 = (DSTR(IBLTE(1),1) + 0.5*ANTE) / DSTRTE
       DSF2 = (DSTR(IBLTE(2),2) + 0.5*ANTE) / DSTRTE
      ELSE
       DSF1 = 0.5
       DSF2 = 0.5
      ENDIF
C
C---- plot upper wake displacement surface
ccc      CALL NEWCOLOR(ICOLS(1))
      CALL NEWCOLOR(ICOL0)
      IBL = IBLTE(1)
      I = IPAN(IBL,1)
      XPLT = X(I) + NX(I)*DSTR(IBL,1)
      YPLT = Y(I) + NY(I)*DSTR(IBL,1)
      CALL PLOT((XPLT+XOFA)*FACA,(YPLT+YOFA)*FACA,3)
      DO 50 IBL=IBLTE(IS)+1, NBL(IS)
        I = IPAN(IBL,IS)
        XPLT = X(I) - NX(I)*DSTR(IBL,IS)*DSF1
        YPLT = Y(I) - NY(I)*DSTR(IBL,IS)*DSF1
        CALL PLOT((XPLT+XOFA)*FACA,(YPLT+YOFA)*FACA,2)
   50 CONTINUE
C
C---- plot lower wake displacement surface
ccc      CALL NEWCOLOR(ICOLS(2))
      CALL NEWCOLOR(ICOL0)
      IBL = IBLTE(2)
      I = IPAN(IBL,2)
      XPLT = X(I) + NX(I)*DSTR(IBL,2)
      YPLT = Y(I) + NY(I)*DSTR(IBL,2)
      CALL PLOT((XPLT+XOFA)*FACA,(YPLT+YOFA)*FACA,3)
      DO 55 IBL=IBLTE(IS)+1, NBL(IS)
        I = IPAN(IBL,IS)
        XPLT = X(I) + NX(I)*DSTR(IBL,IS)*DSF2
        YPLT = Y(I) + NY(I)*DSTR(IBL,IS)*DSF2
        CALL PLOT((XPLT+XOFA)*FACA,(YPLT+YOFA)*FACA,2)
   55 CONTINUE
C
      CALL PLFLUSH
      CALL NEWCOLOR(ICOL0)
C
      RETURN
      END



      SUBROUTINE CPDASH(N,X,CP, XOFA,FACA,PFAC)
C----------------------------------
C     Plot dashed -Cp distribution.
C----------------------------------
      DIMENSION X(N),CP(N)
C
      DO 40 I=2, N
        DX = X(I) - X(I-1)
        DC = CP(I) - CP(I-1)
        CALL PLOT((X(I)-0.75*DX+XOFA)*FACA,-PFAC*(CP(I)-0.75*DC),3)
        CALL PLOT((X(I)-0.25*DX+XOFA)*FACA,-PFAC*(CP(I)-0.25*DC),2)
   40 CONTINUE
C
      RETURN
      END
 

      SUBROUTINE SEQLAB(XLAB,YLAB,XL1,XL2,XL3,XL4,XL5,XL6,
     &                  CHSEQ,IPAR,LVT)
C-------------------------------------------------------------
C     Plots label for alpha- or CL-sequence  Cp vs x  plot.
C-------------------------------------------------------------
      INCLUDE 'XFOIL.INC'
      LOGICAL LVT
C
      EXTERNAL PLCHAR
C
      CHN = 1.10*CH
      CCH = 0.90*CH
      CHS = 0.70*CH
C
      YSPACE = 2.1*CCH
C
C---- x-location of parameter labels
      XLP = XLAB + 1.0*CCH
      IF(LVT) XLP = XLAB + 7.0*CCH
C
      IF(IPAR.EQ.1) THEN
C
C----- plot case name
       CALL NEWPEN(3)
       YLAB = YLAB - CH
       XPLT = XLP + 8.0*CCH - 0.5*CHN*FLOAT(NNAME)
       CALL PLCHAR(XPLT,YLAB,CHN,NAME,0.0,NNAME)
C
       YLAB = YLAB - YSPACE
       CALL NEWPEN(3)
       IF    (MATYP.EQ.1) THEN
        CALL PLCHAR(XLP,YLAB,CCH,'  Ma = ',0.0,7)
       ELSEIF(MATYP.EQ.2) THEN
ccc     CALL PLMATH(XLP,YLAB,CCH,'   _   ',0.0,7)
        CALL PLCHAR(XLP,YLAB,CCH,'Ma C = ',0.0,7)
        CALL PLMATH(XLP,YLAB,CCH,'  R    ',0.0,7)
        CALL PLSUBS(XLP+3.0*CCH,YLAB,CCH,'L',0.0,1,PLCHAR)
       ELSEIF(MATYP.EQ.3) THEN
        CALL PLCHAR(XLP,YLAB,CCH,'Ma C = ',0.0,7)
        CALL PLSUBS(XLP+3.0*CCH,YLAB,CCH,'L',0.0,1,PLCHAR)
       ENDIF
       CALL PLNUMB(XLP+7.0*CCH,YLAB,CCH, MINF1,0.0,3)
C
       IF(LVT) THEN
        YLAB = YLAB - YSPACE
        CALL NEWPEN(3)
        IF    (RETYP.EQ.1) THEN
         CALL PLCHAR(XLP,YLAB,CCH,'  Re = ',0.0,7)
        ELSEIF(RETYP.EQ.2) THEN
ccc      CALL PLMATH(XLP,YLAB,CCH,'   _   ',0.0,7)
         CALL PLCHAR(XLP,YLAB,CCH,'Re C = ',0.0,7)
         CALL PLMATH(XLP,YLAB,CCH,'  R    ',0.0,7)
         CALL PLSUBS(XLP+3.0*CCH,YLAB,CCH,'L',0.0,1,PLCHAR)
        ELSEIF(RETYP.EQ.3) THEN
         CALL PLCHAR(XLP,YLAB,CCH,'Re C = ',0.0,7)
         CALL PLSUBS(XLP+3.0*CCH,YLAB,CCH,'L',0.0,1,PLCHAR)
        ENDIF
        NDIG = 3
        IF(REINF .GE. 9.9995E6) NDIG = 2
        IF(REINF .GE. 99.995E6) NDIG = 1
        IF(REINF .GE. 999.95E6) NDIG = 0
        RE6 = REINF1*1.0E-6
        CALL PLNUMB(XLP+ 7.0*CCH,YLAB        ,     CCH,RE6  ,0.0,NDIG)
        CALL PLMATH(XLP+12.1*CCH,YLAB+0.2*CCH,0.80*CCH,'#'  ,0.0,1)
        CALL PLCHAR(XLP+13.0*CCH,YLAB        ,     CCH,'10' ,0.0,2)
        CALL PLMATH(XLP+15.0*CCH,YLAB        ,1.10*CCH,  '6',0.0,1)
C
        YLAB = YLAB - YSPACE
        CALL NEWPEN(3)
        CALL PLCHAR(XLP        ,YLAB,CCH,'  N  = ',0.0,7)
        CALL PLSUBS(XLP+2.0*CCH,YLAB,CCH,   'cr'  ,0.0,2,PLCHAR)
        CALL PLNUMB(XLP+7.0*CCH,YLAB,CCH,ACRIT    ,0.0,3)
       ENDIF
C
      ENDIF
C
      XL1 = XLAB
      XL2 = XL1 + 7.0*CHS
      XL3 = XL2 + 8.0*CHS
      XL4 = XL3 + 8.0*CHS
      XL5 = XL4 + 9.0*CHS
      XL6 = XL5 + 7.0*CHS
      YLAB = YLAB - 2.7*CHS
      CALL NEWPEN(3)
      CALL PLMATH(XL1+2.0*CHS,YLAB,1.3*CHS,'a',0.0,1)
      CALL PLCHAR(XL2+2.0*CHS,YLAB,CHS,'C',0.0,1)
      CALL PLSUBS(XL2+2.0*CHS,YLAB,CHS,'L',0.0,1,PLCHAR)
      CALL PLCHAR(XL3+2.0*CHS,YLAB,CHS,'C',0.0,1)
      CALL PLSUBS(XL3+2.0*CHS,YLAB,CHS,'M',0.0,1,PLCHAR)
      IF(LVT) THEN
       CALL PLCHAR(XL4+2.5*CHS,YLAB,    CHS,'C',0.0,1)
       CALL PLSUBS(XL4+2.5*CHS,YLAB,    CHS,'D',0.0,1,PLCHAR)
       CALL PLCHAR(XL5        ,YLAB,0.8*CHS,'Top',0.0,3)
       CALL PLCHAR(XL5+3.0*CHS,YLAB,    CHS,'X'  ,0.0,1)
       CALL PLCHAR(XL5+3.9*CHS,YLAB,0.6*CHS,'tr' ,0.0,2)
       CALL PLCHAR(XL6        ,YLAB,0.8*CHS,'Bot',0.0,3)
       CALL PLCHAR(XL6+3.0*CHS,YLAB,    CHS,'X'  ,0.0,1)
       CALL PLCHAR(XL6+3.9*CHS,YLAB,0.6*CHS,'tr' ,0.0,2)
      ENDIF
C
      CALL NEWPEN(1)
      CALL PLOT(XL1        ,YLAB-0.6*CHS,3)
      CALL PLOT(XL1+5.0*CHS,YLAB-0.6*CHS,2)
      CALL PLOT(XL2        ,YLAB-0.6*CHS,3)
      CALL PLOT(XL2+6.0*CHS,YLAB-0.6*CHS,2)
      CALL PLOT(XL3        ,YLAB-0.6*CHS,3)
      CALL PLOT(XL3+6.0*CHS,YLAB-0.6*CHS,2)
      IF(LVT) THEN
       CALL PLOT(XL4        ,YLAB-0.6*CHS,3)
       CALL PLOT(XL4+7.0*CHS,YLAB-0.6*CHS,2)
       CALL PLOT(XL5        ,YLAB-0.6*CHS,3)
       CALL PLOT(XL5+5.0*CHS,YLAB-0.6*CHS,2)
       CALL PLOT(XL6        ,YLAB-0.6*CHS,3)
       CALL PLOT(XL6+5.0*CHS,YLAB-0.6*CHS,2)
      ENDIF
C
      YLAB = YLAB - 0.5*CHS
C
      CHSEQ = CHS
      RETURN
      END


      SUBROUTINE SEQPLT(YLAB,XL1,XL2,XL3,XL4,XL5,XL6,
     &                  CHS,ALT,CLT,CMT,LVT)
C------------------------------------------------
C     Plots force coefficients for one point on
C     alpha- or CL-sequence  Cp vs x  plot.
C------------------------------------------------
      INCLUDE 'XFOIL.INC'
      LOGICAL LVT
C
      CALL NEWPEN(2)
      DXL1 = 0.
      DXL2 = 0.
      DXL3 = CHS
      DXL4 = 0.
      IF(ALT .LT. 0.0) DXL1 = DXL1 - CHS
      IF(CLT .LT. 0.0) DXL2 = DXL2 - CHS
      IF(CMT .LT. 0.0) DXL3 = DXL3 - CHS
      IF(CD  .LT. 0.0) DXL4 = DXL4 - CHS
      IF(ALT .GE. 10.) DXL1 = DXL1 - CHS
      IF(ALT .LE.-10.) DXL1 = DXL1 - CHS
C
      YLAB = YLAB - 2.1*CHS
      CALL PLNUMB(XL1+DXL1,YLAB,CHS,ALT,0.0,3)
      CALL PLNUMB(XL2+DXL2,YLAB,CHS,CLT,0.0,4)
      CALL PLNUMB(XL3+DXL3,YLAB,CHS,CMT,0.0,3)
      IF(LVT) THEN
       CALL PLNUMB(XL4+DXL4,YLAB,CHS,      CD,0.0,5)
       CALL PLNUMB(XL5     ,YLAB,CHS,XOCTR(1),0.0,3)
       CALL PLNUMB(XL6     ,YLAB,CHS,XOCTR(2),0.0,3)
      ENDIF
C
      RETURN
      END




      SUBROUTINE COEFPL(XL,YL,CH,LVISC,LFOREF,LVCONV,
     &                  NAME,NNAME,
     &                  REINF,MINF,ACRIT,ALFA,CL,CM,CD,CDP)
C------------------------------------------------------------------
C     Plots force coefficients for single-point  Cp vs x  plot.
C
C     XL,YL   upper-left corner of label block, 
C             returned as location of lower-left corner
C
C------------------------------------------------------------------
      LOGICAL LVISC, LFOREF, LVCONV
      CHARACTER*(*) NAME
      REAL MINF
C
      EXTERNAL PLCHAR
C
      CHN = 1.10*CH
      CCH = 0.90*CH
      SCH = 0.70*CH
C
      YSPACE = 2.2*CCH
C
      ADEG = ALFA * 45.0/ATAN(1.0)
C
      CALL GETCOLOR(ICOL0)
C
      CALL NEWPEN(3)
      XPLT1 = XL + 16.0*CCH -     FLOAT(NNAME)*CHN
      XPLT2 = XL +  6.0*CCH - 0.5*FLOAT(NNAME)*CHN
      IF(     LFOREF) XPLT = MIN( XPLT1 , XPLT2 )
      IF(.NOT.LFOREF) XPLT = XPLT2
      YL = YL - CHN
      CALL PLCHAR(XPLT,YL,CHN,NAME,0.0,NNAME)
C
      YL = YL - 0.2*CH
      CALL NEWPEN(2)
C
      IF(MINF .GT. 0.0) THEN
       YL = YL - 2.0*CH
       CALL PLCHAR(XL        ,YL,CCH,'Ma = ',0.0,5)
       CALL PLNUMB(XL+5.0*CCH,YL,CCH, MINF  ,0.0,4)
      ENDIF
C
      IF(LVISC) THEN
       YL = YL - YSPACE
       CALL PLCHAR(XL         ,YL         ,CCH,'Re = '   ,0.0,5)
       NDIG = 3
       IF(REINF .GE. 9.9995E6) NDIG = 2
       IF(REINF .GE. 99.995E6) NDIG = 1
       IF(REINF .GE. 999.95E6) NDIG = 0
       CALL PLNUMB(XL+ 5.0*CCH,YL         ,CCH, REINF*1.E-6,0.0,NDIG)
       CALL PLMATH(XL+10.1*CCH,YL+0.10*CCH,0.80*CCH,'#'  ,0.0,1)
       CALL PLCHAR(XL+10.9*CCH,YL         ,     CCH,'10' ,0.0,2)
       CALL PLMATH(XL+12.9*CCH,YL         ,1.10*CCH,  '6',0.0,1)
      ENDIF
C
      YL = YL - YSPACE
      CALL PLMATH(XL        ,YL,1.2*CCH,'a',0.0,1)
      CALL PLMATH(XL        ,YL,CCH,'   = ',0.0,5)
      CALL PLNUMB(XL+5.0*CCH,YL,CCH, ADEG  ,0.0,4)
      CALL PLMATH(999.0     ,YL,CCH,'"'    ,0.0,1)
C
      YL = YL - YSPACE
      CALL PLCHAR(XL        ,YL,CCH,'C  = ',0.0,5)
      CALL PLSUBS(XL        ,YL,CCH, 'L'   ,0.0,1,PLCHAR)
      CALL PLNUMB(XL+5.0*CCH,YL,CCH, CL    ,0.0,4)
C
      YL = YL - YSPACE
      CALL PLCHAR(XL        ,YL,CCH,'C  = ',0.0,5)
      CALL PLSUBS(XL        ,YL,CCH, 'M'   ,0.0,1,PLCHAR)
      CALL PLNUMB(XL+5.0*CCH,YL,CCH, CM    ,0.0,4)
C
      IF(.NOT.LVISC) THEN
       YL = YL - YSPACE
       CALL PLCHAR(XL        ,YL,CCH,'C  = ',0.0,5)
       CALL PLSUBS(XL        ,YL,CCH, 'Dp'  ,0.0,2,PLCHAR)
       CALL PLNUMB(XL+5.0*CCH,YL,CCH, CDP   ,0.0,5)
      ENDIF
C
      IF(LVISC) THEN
       YL = YL - YSPACE
       CALL PLCHAR(XL        ,YL,CCH,'C  = ',0.0,5)
       CALL PLSUBS(XL        ,YL,CCH, 'D'   ,0.0,1,PLCHAR)
       CALL PLNUMB(XL+5.0*CCH,YL,CCH, CD    ,0.0,5)
C
       ELOD = 0.
       IF(CD.NE.0.0) ELOD = CL/CD
C
       YL = YL - YSPACE
       CALL PLCHAR(XL        ,YL,0.8*CCH,'L/D',0.0,3)
       CALL PLCHAR(XL        ,YL,CCH,'   = ',0.0,5)
       CALL PLNUMB(XL+5.0*CCH,YL,CCH, ELOD  ,0.0,2)
C
       YL = YL - YSPACE
       CALL PLCHAR(XL        ,YL,CCH,'N  = ',0.0,5)
       CALL PLSUBS(XL        ,YL,CCH, 'cr'  ,0.0,2,PLCHAR)
       CALL PLNUMB(XL+5.0*CCH,YL,CCH, ACRIT ,0.0,2)
C
      ENDIF
C
      IF(LVISC .AND. .NOT.LVCONV) THEN
       CALL NEWCOLORNAME('red')
       YL = YL - 3.0*CCH
       CALL PLCHAR(XL-5.0*CCH,YL,1.5*CCH,'* NOT CONVERGED *',0.0,17)
      ENDIF
C
      CALL NEWCOLOR(ICOL0)
C
      RETURN
      END



      SUBROUTINE FOREF(XL,YL,CH,LVISC, MINF )
C---------------------------------------------
C     Plots reference data force coefficients
C     next to calculated coefficients.
C
C     XL,YL   upper-left corner of label block, 
C             returned as location of lower-left corner
C
C---------------------------------------------
      LOGICAL LVISC
      REAL MINF
C
      CHARACTER*32 LABEXP
C
      CHN = 1.10*CH
      CCH = 0.90*CH
C
      YSPACE = 2.2*CCH
C
      XL0 = XL
      YL0 = YL
C
      CALL PLFLUSH
 10   WRITE(*,*) 'Enter reference  Mach, Re, Alpha, CL, CD, CM:'
      READ(*,*,ERR=10) AMEX, REEX, ALEX, CLEX, CDEX, CMEX
C
      XL = XL + 18.5*CCH
      YL = YL - CHN
C
      YL = YL - 0.2*CH
      CALL NEWPEN(2)
C
      IF(MINF .GT. 0.0) THEN
       YL = YL - YSPACE
       CALL PLNUMB(XL,YL,CCH,AMEX,0.0,3)
      ENDIF
C
      IF(LVISC) THEN
       YL = YL - YSPACE
       CALL PLNUMB(XL,YL,CCH,REEX*1.0E-6,0.0,3)
       CALL PLMATH(XL+5.0*CCH,YL+0.10*CCH,0.80*CCH,'#'  ,0.0,1)
       CALL PLCHAR(XL+5.8*CCH,YL         ,     CCH,'10' ,0.0,2)
       CALL PLMATH(XL+7.8*CCH,YL         ,1.10*CCH,  '6',0.0,1)
      ENDIF
C
      YL = YL - YSPACE
      CALL PLNUMB(XL,YL,CCH,ALEX,0.0,3)
C
      YL = YL - YSPACE
      CALL PLNUMB(XL,YL,CCH,CLEX,0.0,4)
C
      YL = YL - YSPACE
      CALL PLNUMB(XL,YL,CCH,CMEX,0.0,4)
C
      IF(LVISC) THEN
       YL = YL - YSPACE
       CALL PLNUMB(XL,YL,CCH,CDEX,0.0,5)
C
       YL = YL - YSPACE
       ELOD = 0.0
       IF(CDEX.NE.0.0) ELOD = CLEX/CDEX
       CALL PLNUMB(XL,YL,CCH,ELOD,0.0,2)
      ENDIF
C
      CALL NEWPEN(1)
      XLIN = XL - 1.5*CCH
      CALL PLOT(XLIN,YL0,3)
      CALL PLOT(XLIN,YL ,2)
C
      CALL PLFLUSH
C
      CALL ASKS('Enter reference force data label^',LABEXP)
      CALL NEWPEN(3)
      YL1 = YL0 - CHN
      CALL PLCHAR(XL,YL1,0.9*CHN,LABEXP,0.0,-1)
C
      RETURN
      END



      SUBROUTINE CPVEC
C-------------------------------------------------------
C     Plots airfoil with normal pressure force vectors.
C-------------------------------------------------------
      INCLUDE 'XFOIL.INC'
ccc      CHARACTER*4 CHDUM
C
      DO 2 I=1, N
        W1(I) = X(I)
        W2(I) = Y(I)
 2    CONTINUE
C
      CALL ROTATE(W1,W2,N,ALFA)
      CALL NCALC(W1,W2,S,N,W3,W4)
C
C---- set geometric limits
      XMIN = W1(1)
      XMAX = W1(1)
      YMIN = W2(1)
      YMAX = W2(1)
      DO 5 I=1, N
        XMIN = MIN(XMIN,W1(I))
        XMAX = MAX(XMAX,W1(I))
        YMIN = MIN(YMIN,W2(I))
        YMAX = MAX(YMAX,W2(I))
 5    CONTINUE
C
C---- set pressure vector scale VSF
      XRANGE = MAX(1.0E-9, XMAX-XMIN)
      YRANGE = MAX(1.0E-9, YMAX-YMIN)
      VSF = VFAC / MIN( 1.0/XRANGE , PLOTAR/YRANGE )
C
C
C---- set limits again, including pressure vectors
      DO 8 I=1, N
        IF(     LVISC) CP = CPV(I)
        IF(.NOT.LVISC) CP = CPI(I)
        DX = ABS(CP)*VSF*W3(I)
        DY = ABS(CP)*VSF*W4(I)
        XMIN = MIN(XMIN,W1(I)+DX)
        XMAX = MAX(XMAX,W1(I)+DX)
        YMIN = MIN(YMIN,W2(I)+DY)
        YMAX = MAX(YMAX,W2(I)+DY)
 8    CONTINUE
C
C---- set scale, offsets, to center airfoil+vectors in plot area
      XRANGE = MAX(1.0E-9, XMAX-XMIN)
      YRANGE = MAX(1.0E-9, YMAX-YMIN)
      GSF = MIN( 1.0/XRANGE , PLOTAR/YRANGE )
      XOFG = XMIN - 0.5*(1.0   -GSF*XRANGE)/GSF - 0.05/GSF
      YOFG = YMIN - 0.5*(PLOTAR-GSF*YRANGE)/GSF - 0.05/GSF
C
      CALL PLTINI
C
      CALL NEWPEN(2)
      CALL PLOT((W1(1)-XOFG)*GSF,(W2(1)-YOFG)*GSF,3)
      DO 10 I=2, N
        CALL PLOT((W1(I)-XOFG)*GSF,(W2(I)-YOFG)*GSF,2)
   10 CONTINUE
C
      DO 20 I=2, N-1
        IF(     LVISC) CP = CPV(I)
        IF(.NOT.LVISC) CP = CPI(I)
        DX = -CP*VSF*W3(I)*GSF
        DY = -CP*VSF*W4(I)*GSF
        XL = (W1(I)-XOFG)*GSF
        YL = (W2(I)-YOFG)*GSF
        IF(CP.LT.0.0) CALL ARROW(XL   ,YL   ,DX,DY)
        IF(CP.GE.0.0) CALL ARROW(XL-DX,YL-DY,DX,DY)
   20 CONTINUE
C
      CALL PLFLUSH
ccc      CALL ASKC('hit <cr>^',CHDUM,COMARG)
      RETURN
      END


      SUBROUTINE PPAPLT(NPPAI,IPPAI)
      DIMENSION IPPAI(*)
C-------------------------------------------
C     Plots mutiple polar airfoils overlaid
C-------------------------------------------
      INCLUDE 'XFOIL.INC'
C
      DATA LMASK1, LMASK2, LMASK3 / -32640, -30584, -21846 /
      INCLUDE 'XDES.INC'
C
      CALL PLTINI
      CALL GOFINI
C
      CALL NEWPEN(1)
C
      IF(LGGRID) THEN
C------ plot outline
ccc     CALL PLOT(XMOD(XGMIN),YMOD(YGMIN),3)
        CALL PLOT(XMOD(XGMAX),YMOD(YGMIN),3)
        CALL PLOT(XMOD(XGMAX),YMOD(YGMAX),2)
        CALL PLOT(XMOD(XGMIN),YMOD(YGMAX),2)
ccc     CALL PLOT(XMOD(XGMIN),YMOD(YGMIN),2)
C
        CALL XAXIS(XMOD(XGMIN),YMOD(YGMIN),(XGMAX-XGMIN)*XSF,
     &             DXYG*XSF, XGMIN,DXYG,CHG,-2)
        CALL YAXIS(XMOD(XGMIN),YMOD(YGMIN),(YGMAX-YGMIN)*YSF,
     &             DXYG*YSF, YGMIN,DXYG,CHG,-2)
C
C------ fine grid
        NXG = INT((XGMAX-XGMIN)/DXYG + 0.01)
        NYG = INT((YGMAX-YGMIN)/DXYG + 0.01)
        X0 = XMOD(XGMIN)
        Y0 = YMOD(YGMIN)
        DXG = (XMOD(XGMAX)-X0)/NXG
        DYG = (YMOD(YGMAX)-Y0)/NYG
        CALL PLGRID(X0,Y0,NXG,DXG,NYG,DYG, LMASK2)
C
        XL0 = XMOD(XGMIN) + 1.0*CH
        YL0 = YMOD(YGMAX) + 3.0*CH
      ELSE
C
C------ plot chord line and tick marks every 10% chord
        CALL PLOT(XMOD(0.0),YMOD(0.0),3)
        CALL PLOT(XMOD(1.0),YMOD(0.0),2)
        DO 10 ITICK=1, 10
          XPLT = FLOAT(ITICK)/10.0
          CALL PLOT(XMOD(XPLT),YMOD(0.003),3)
          CALL PLOT(XMOD(XPLT),YMOD(-.003),2)
   10   CONTINUE
C
        XL0 = XMOD(XBMIN) + 1.0*CH
        YL0 = YMOD(YBMAX) + 3.0*CH
      ENDIF
C
      CALL GETCOLOR(ICOL0)
C
      CALL NEWPEN(2)
      CALL PLTAIR(X,XP,Y,YP,S,N, XOFF,XSF,YOFF,YSF,'black')
C
      XLAB = XL0
      YLAB = YL0
      CHL = CH
      DO 40 K = NPPAI, 1, -1
        IP = IPPAI(K)
        IF(IP.EQ.0) GO TO 40
C
C------- plot airfoil if it's archived
         NXY = NXYPOL(IP)
         IF(NXY.GT.1) THEN
          CALL SCALC(CPOLXY(1,1,IP),CPOLXY(1,2,IP),W3,NXY)
          CALL SPLINE(CPOLXY(1,1,IP),W1,W3,NXY)
          CALL SPLINE(CPOLXY(1,2,IP),W2,W3,NXY)
C
          CALL NEWCOLOR(ICOLP(IP))
          CALL PLTAIR(CPOLXY(1,1,IP),W1,
     &                CPOLXY(1,2,IP),W2, W3,NXY,
     &                XOFF,XSF,YOFF,YSF,' ')
C
C-------- also plot its number and name
          CALL STRIP(NAMEPOL(IP),NNAMEP)
          PFLT = FLOAT(IP)
          CALL PLNUMB(XLAB,YLAB,CHL,PFLT,0.0,-1)
          CALL PLCHAR(XLAB+3.0*CHL,YLAB,CHL,NAMEPOL(IP),0.0,NNAMEP)
          YLAB = YLAB + 2.5*CHL
         ENDIF
 40   CONTINUE
C
      CALL PLFLUSH
C
      RETURN
      END ! PPAPLT


 
      SUBROUTINE RESETSCL
C---- Resets scales, offsets for zooming 
C     uses  offsets XOFF,YOFF 
C     scale factors XSF,YSF
      INCLUDE 'XFOIL.INC'
      XOFF = 0.0
      YOFF = 0.0
      XSF  = 1.0
      YSF  = 1.0
      RETURN
      END
 





